--RandomMount V0.2
--Author: Mike Hendricks(AttilaTheFun)
--Description:
--              This add-on makes it simple to summon a random mount it takes into account ridding level, cold weather flying,
--              flying areas, even race and summons an appropriate mount.
--              It has a simple interface /mnt: will summon riding/flying mounts in the appropriate areas
--                                        /mnt riding: summons riding mounts in flying areas
--                                        /mnt search %t: summons a mount based on specified search term.
--                                              example: to summon a skeletal warhorse type: /mnt search skeletal
--If you are a Tauren and in undercity most mounts are to large to get easily throug out of the elivators, so if you have wolf,
-- or skeletal warhorses it will summon only those inside of undercity.


-- mount dictionary to compensate for wow's terrible GetCompanionInfo("MOUNT", i) command.
--One would assume info would imply useful things like can it fly and what skill is required etc.
-- mount codes --
-- add the numbers together for special mounts. ie both epic riding and epic flying = 20
--1  = slow Mount(Not Summoned)
--2  = riding mount
--4  = epic riding mount
--8  = flying mount
--16 = epic flying mount
--32 = special mount(for area specific mounts)
local mountDict = {["Winged Steed of the Ebon Blade"] = 24,
["Swift Red Wind Rider"] = 16,
["Swift Green Wind Rider"] = 16,
["Swift Yellow Wind Rider"] = 16,
["Swift Purple Wind Rider"] = 16,
["Swift Blue Gryphon"] = 16,
["Swift Green Gryphon"] = 16,
["Swift Purple Gryphon"] = 16,
["Swift Red Gryphon"] = 16,
["Blue Riding Nether Ray"] = 16,
["Purple Riding Nether Ray"] = 16,
["Green Riding Nether Ray"] = 16,
["Red Riding Nether Ray"] = 16,
["Silver Riding Nether Ray"] = 16,
["Violet Netherwing Drake"] = 16,
["Veridian Netherwing Drake"] = 16,
["Azure Netherwing Drake"] = 16,
["Onyx Netherwing Drake"] = 16,
["Purple Netherwing Drake"] = 16,
["Cobalt Netherwing Drake"] = 16,
["Azure Drake"] = 16,
["Blue Drake"] = 16,
["Albino Drake"] = 16,
["Bronze Drake"] = 16,
["Red Drake"] = 16,
["Twilight Drake"] = 16,
["Black Drake"] = 16,
["Cenarion War Hippogryph"] = 16,
["Armored Snowy Gryphon"] = 16,
["Armored Blue Wind Rider"] = 16,
["Flying Carpet"] = 16,
["Flying Machine"] = 16,
["Turbo-Charged Flying Machine"] = 16,
["Albino Drake"] = 16,
["Red Proto-Drake"] = 16,
["Blue Proto-Drake"] = 16,
["Green Proto-Drake"] = 16,
["Plagued Proto-Drake"] = 16,
["Black Proto-Drake"] = 16,
["Time-Lost Proto-Drake"] = 16,
["Swift Nether Drake"] = 16,
["X-51 Nether-Rocket"] = 16,
["X-51 Nether-Rocket X-TREME"] = 16,
["Tawny Wind Rider"] = 8,
["Blue Wind Rider"] = 8,
["Green Wind Rider"] = 8,
["Ebon Gryphon"] = 8,
["Golden Gryphon"] = 8, 
["Snowy Gryphon"] = 8,
["Swift Green Hawkstrider"] = 4,
["Swift Pink Hawkstrider"] = 4,
["Swift Purple Hawkstrider"] = 4,
["Great Blue Elekk"] = 4,
["Great Green Elekk"] = 4, 
["Great Purple Elekk"] = 4,
["Swift Brown Wolf"] = 36,
["Swift Timber Wolf"] = 36,
["Swift Gray Wolf"] = 36,
["Purple Skeletal Warhorse"] = 36,
["Green Skeletal Warhorse"] = 36,
["Swift Blue Raptor"] = 36,
["Swift Olive Raptor"] = 36,
["Swift Orange Raptor"] = 36,
["Swift Gray Ram"] = 4,
["Swift Brown Ram"] = 4,
["Swift White Ram"] = 4,
["Swift Mistsaber"] = 4, 
["Swift Stormsaber"] = 4,
["Swift Frostsaber"] = 4,
["Swift Green Mechanostrider"] = 4,
["Swift Yellow Mechanostrider"] = 4,
["Swift White Mechanostrider"] = 4,
["Great Gray Kodo"] = 4,
["Great White Kodo"] = 4,
["Great Brown Kodo"] = 4,
["Swift Palomino"] = 4,
["Swift White Steed"] = 4,
["Swift Brown Steed"] = 4,
["Charger"] = 4,
["Dreadsteed"] = 4,
["Acherus Deathcharger"] = 4,
["Red Skeletal Warhorse"] = 36,
["Black War Steed"] = 4,
["Black War Wolf"] = 36,
["Black War Tiger"] = 4, 
["Black War Kodo"] = 4,
["Black War Ram"] = 4,
["Black War Raptor"] = 36,
["Black Battlestrider"] = 4,
["Swift Warstrider"] = 4,
["Black War Elekk"] = 4,
["Dark War Talbuk"] = 4,
["Dark Riding Talbuk"] = 4,
["Stormpike Battle Charger"] = 4,
["Frostwolf Howler"] = 36,
["Big Blizzard Bear"] = 4,
["Black War Bear"] = 4,
["Armored Brown Bear"] = 4, 
["White Polar Bear"] = 4,
["Big Battle Bear"] = 4,
["Wooly Mammoth"] = 4,
["Traveler's Tundra Mammoth"] = 4,
["Mekgineer's Chopper"] = 4,
["Mechano-Hog"] = 4, 
["Swift White Hawkstrider"] = 4,
["Amani War Bear"] = 4,
["Fiery Warhorse"] = 4,
["Swift Spectral Tiger"] = 6,
["Swift Zhevra"] = 4,
["Raven Lord"] = 4, 
["Rivendare's Deathcharger"] = 36,
["Winterspring Frostsaber"] = 4,
["Swift Razzashi Raptor"] = 4,
["Swift Zulian Tiger"] = 4,
["Black Qiraji Battle Tank"] = 4,
["Great Brewfest Kodo"] = 4,
["Brewfest Ram"] = 4,
["Cobalt Riding Talbuk"] = 4,
["Silver Riding Talbuk"] = 4,
["Tan Riding Talbuk"] = 4,
["White Riding Talbuk"] = 4,
["Cobalt War Talbuk"] = 4,
["Silver War Talbuk"] = 4,
["Tan War Talbuk"] = 4,
["White War Talbuk"] = 4,
["Black Hawkstrider"] = 2,
["Blue Hawkstrider"] = 2,
["Purple Hawkstrider"] = 2,
["Red Hawkstrider"] = 2,
["Brown Elekk"] = 2,
["Gray Elekk"] = 2,
["Purple Elekk"] = 2,
["Dire Wolf"] = 34,
["Timber Wolf"] = 34,
["Brown Wolf"] = 34,
["Red Skeletal Horse"] = 34,
["Blue Skeletal Horse"] = 34,
["Brown Skeletal Horse"] = 34,
["Violet Raptor"] = 34,
["Emerald Raptor"] = 34,
["Turquoise Raptor"] = 34,
["White Ram"] = 2,
["Brown Ram"] = 2,
["Gray Ram"] = 2,
["Spotted Frostsaber"] = 2,
["Striped Frostsaber"] = 2,
["Striped Nightsaber"] = 2,
["Unpainted Mechanostrider"] = 2,
["Red Mechanostrider"] = 2,
["Blue Mechanostrider"] = 2,
["Green Mechanostrider"] = 2,
["Brown Kodo"] = 2,
["Gray Kodo"] = 2,
["Pinto"] = 2,
["Brown Horse"] = 2,
["Black Stallion"] = 2,
["Chestnut Mare"] = 2,
["Felsteed"] = 2,
["Blue Qiraji Battle Tank"] = 32,
["Green Qiraji Battle Tank"] = 32,
["Red Qiraji Battle Tank"] = 32,
["Yellow Qiraji Battle Tank"] = 32,
["Headless Horseman's Mount"] = 20,
["Frost Ram"] = 4,
["Green Kodo"] = 4,
["White Mechanostrider Mod B"] = 4,
["Merciless Nether Drake"] = 16,
["White Stallion"] = 4,
["Black War Mammoth"] = 4,
["Winter Wolf"] = 4,
["Grand Ice Mammoth"] = 4,
["Brutal Nether Drake"] = 16,
["Ashes of Al'ar"] = 16,
["Red Wolf"] = 4,
["Ivory Raptor"] = 4,
["Swift Brewfest Ram"] = 4,
["Black Nightsaber"] = s4,
["Mottled Red Raptor"] = 4,
["Black Ram"] = 4,
["Teal Kodo"] = 4,
["Icy Blue Mechanostrider Mod A"] = 4,
["Vengeful Nether Drake"] = 16,
["Palomino"] = 4,
["Magnificent Flying Carpet"] = 16,
["Ancient Frostsaber"] = 4,
["Icy Blue Mechanostrider Mod A"] = 4,
["Ice Mammoth"] = 4,
["Riding Turtle"] = 1}

local debug = false

--names to check for cold weather flying
local zoneIndex = {"Howling Fjord", "Borean Tundra", "Dragonblight", "Grizzly Hills", "Zul'Drak", "Sholazar Basin",
            "The Storm Peaks", "Crystalsong Forest", "Icecrown", "Windergrasp", "Coldarra", "The Frozen Sea"}

function RandomMount_OnLoad()
 SlashCmdList["ADDONNAME"] = FindMount;
 SLASH_ADDONNAME1 = "/mnt";
end

function CanFlyHere( )
	-- Check for flyable area
	if not IsFlyableArea( ) then return( false ) end

	local coldWeather = IsUsableSpell( "Cold Weather Flying" )

	-- Check for Dalaran
	if GetRealZoneText( ) == "Dalaran" then
		if (GetMinimapZoneText( ) == "Krasus' Landing" or GetMinimapZoneText() == "The Underbelly") and coldWeather then
            return( true )
        end
		return( false )
	end

	-- Northrend check
	local zoneText = GetRealZoneText()
	for i, zone in ipairs( zoneIndex ) do
        if zoneText == zone then
			if coldWeather then return( true ) end
			return( false )
		end
	end

	return( true )
end

function GetRidingSkill()
    --get the current riding skill
    for skillIndex = 1, GetNumSkillLines() do
      skillName, isHeader, _, skillRank = GetSkillLineInfo(skillIndex)
        if isHeader == nil then
          if skillName == "Riding" then
              return( skillRank )
          end
        end
    end
    return ( 0 )
end

function HasZoneMounts(flying, wolf, qiraji, searchMount, search)
    --check to see if special zone mounts are learned and process search
    for i=1,GetNumCompanions("MOUNT"),1 do
        local _, creatureName = GetCompanionInfo("MOUNT", i)
        if search ~= '' then
            if string.find(string.lower(creatureName), string.lower(search)) then
                table.insert(searchMount, i)
            end
        end
        if creatureName:find("Wolf") then
            table.insert(wolf, i)
        elseif creatureName:find("Skeletal") then
            table.insert(wolf, i)
        elseif creatureName:find("Rivendare") then
            table.insert(wolf, i)
        elseif creatureName:find("Qiraji") then
            table.insert(qiraji, i)
        elseif ((mountDict[creatureName] / 8) % 2) >= 1 or ((mountDict[creatureName] / 16) % 2) >= 1 then
            table.insert(flying, i)
        end
    end
    return flying, wolf, qiraji, searchMount
end

function FindMount(arg1)
	local s = 0
	local r
    local wolf = {}
    local qiraji = {}
    local flying = {}
    local search = ""
    local searchMount = {}
	local zoneText = GetRealZoneText()
    local zoneMounts = 2
    local canFly
    local ridingSK = GetRidingSkill()

    if arg1 == "riding" then
        canFly = false
    elseif arg1 == "help" then
        PrintHelp("Random Mount optional flags:\r riding: Summon only ground based mounts\r flying: If available summon flying mounts\r search %t: Summon a mount that has %t somewhere in its name\r debug: Toggle debug printing for posting error messages\r No Flag: Summon a appropriate mount for the area", "FFFFFF00")return
    elseif arg1 == "debug" then
        if debug == false then 
            debug = true
        elseif debug == true then 
            debug = false
        end
        canFly = CanFlyHere()
    elseif arg1:find("search") then
        search = string.sub(arg1, 8)
        canFly = CanFlyHere()
    else
        canFly = CanFlyHere()
    end
    local flying, wolf, qiraji, searchMount = HasZoneMounts(flying, wolf, qiraji, searchMount, search)
    if search ~= "" and next (searchMount) == nil then
        PrintHelp("No matching mount found.", "FF00ffff") return
    end
    if IsMounted()
        then Dismount() return
    end
    local runawayChk = 0
    if ridingSK >= 75 then
    	repeat
    		r = random(GetNumCompanions("MOUNT"))
    		s = TestMount(r, ridingSK, zoneText, canFly, flying, wolf, qiraji, searchMount, debug)
    		runawayChk = runawayChk + 1
    		if runawayChk > 500 then
                canFly = false
    		elseif runawayChk > 1000 then
                s = 1
    		end
    	until s == 1
    	if runawayChk > 1000 then
    	   PrintHelp("i've run away", "FF00ffff")
    	else
            CallCompanion("MOUNT", r)
        end
    end
end

function TestMount(r, ridingSK, zoneText, canFly, flying, wolf, qiraji, searchMount, debug)
    local _, creatureName = GetCompanionInfo("MOUNT", r)
    local mv = mountDict[creatureName]
    if mv then
        --flying mounts
        if canFly and #flying > 0 and ridingSK >= 225 then
            if ridingSK >= 300 and ((mv/ 16) % 2) >= 1 then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 10) end
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            return(1)
                        end
                    end
                else
                    return(1)
                end
            elseif ridingSK == 225 and ((mv / 8) % 2) >= 1 then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 20) end
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            return(1)
                        end
                    end
                else
                    return(1)
                end
            end
        --zone specific mounts
        elseif zoneText == "Undercity" and #wolf > 0  and UnitRace("player") == "Tauren" then
            if ridingSK >= 150 and ((mv / 32) % 2) >= 1 and ((mv / 4) % 2) >= 1 and (creatureName:find("Wolf") or creatureName:find("Skeletal") or creatureName:find("Rivendare")) then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 30) end
                return(1)
            elseif ridingSK == 75 and ((mv / 32) % 2) >= 1 and ((mv / 2) % 2) >= 1 and (creatureName:find("Wolf") or creatureName:find("Skeletal") or creatureName:find("Rivendare")) then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 40) end
                return(1)
            end
        elseif zoneText == "Ahn'Qiraj" and #qiraji > 0 then
            if ridingSK >= 150 and ((mv / 32) % 2) >= 1 and creatureName:find("Qiraji") then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 35) end
                return(1)
            end
        --Regular Mounts
        else
            if ridingSK >= 150 and ((mv / 4) % 2) >= 1 then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 50) end
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            return(1)
                        end
                    end
                else
                    return(1)
                end
            elseif ridingSK == 75 and ((mv / 2) % 2) >= 1 then
                if debug then PrintSummon("FF00ffff", creatureName, r, ridingSK, mountDict[creatureName], zoneText, canFly, 60) end
                if #searchMount > 0 then
                    for i, s in ipairs(searchMount) do
                        if r == s then
                            return(1)
                        end
                    end
                else
                    return(1)
                end
            end
        end
    end
end



function PrintHelp(cmd, color)
	print(format('|c%s%s|r', color, cmd))
end

function PrintSummon(color, creatureName, r, ridingSK, creatureDict, zoneText, canFly, mountNum)
    canFly = tostring(canFly)
	print(format("|c%s%s - Mnt#:%s - Skill: %s - type:%s - %s - %s - flyZone:%s - cond:%s|r", color, creatureName, r, ridingSK, creatureDict, zoneText, GetMinimapZoneText(), canFly, mountNum))
end